<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <style>
  body {font-family: Calibri, Georgia; font-size: 11pt; }
  h1, h2, h3 {font-family: Cambria, Arial, Helvetica; font-weight: lighter; color: #12945b;}
  h1 {font-size: 26pt; }
  h2 {font-size: 14pt; }
  h3 {font-size: 12pt; }
  code {font-family: Courier New; font-weight: bold; color: blue }
  table {border-radius: 5px; border: 2px solid black; }
  td, th {border: 1px solid gray; }
  ul.innerlist {list-style: none; margin: 0; padding: 0}
  td, pre {color: blue}
  </style>
</head>
<body>
<div id="content">
<h1>CSC 333/Cryptology<br />Week 5 assignment solution</h1>
<hr />
<h2>AES encryption (60 points)</h2>
<p>
The program was to be tested on the inputs specified in Appendix B of the FIPS-197 AES document. Because I said one thing in class but gave a different thing in the assignment, the correct solution can be either the state after calling MixColumns in round 1 or the state after the AddRoundKey in round 1.  I've provided both answers here, along with the expected output of each preceding step and as documented on page 33 of the FIPS document.
<pre>
After round 0 AddRoundKey: 19 a0 9a e9 3d f4 c6 f8 e3 e2 8d 48 be 2b 2a 08
After round 1 SubBytes:    d4 e0 b8 1e 27 bf b4 41 11 98 5d 52 ae f1 e5 30
After round 1 ShiftRows:   d4 e0 b8 1e bf b4 41 27 5d 52 11 98 30 ae f1 e5
After round 1 MixColumns:  04 e0 48 28 66 cb f8 06 81 19 d3 26 e5 9a 7a 4c
After round 1 AddRoundKey: a4 68 6b 02 9c 9f 5b 6a 7f 35 ea 50 f2 2b 43 49
</pre>
The correct output can either the fourth or the fifth line of the above.
</p>
<p>
Here is tabular presentation of the same output:
<pre>
Round    Start of                                         Round key       After
          Round                                                        AddRoundKey

       32 88 31 e0                                     2b 28 ab 09     19 a0 9a e9
  0    43 5a 31 37                                     7e ae f7 cf     3d f4 c6 f8
       f6 30 98 07                                     15 d2 15 4f     e3 e2 8d 48
       a8 8d a2 34                                     16 a6 88 3c     be 2b 2a 08

          After           After           After          Round key        After
        SubBytes       ShiftRows        MixColumns                     AddRoundKey

       d4 e0 b8 1e     d4 e0 b8 1e     04 e0 48 28     a0 88 23 2a     a4 68 6b 02
  1    27 bf b4 41     bf b4 41 27     66 cb f8 06     fa 54 a3 6c     9c 9f 5b 6a
       11 98 5d 52     5d 52 11 98     81 19 d3 26     fe 2c 39 76     7f 35 ea 50
       ae f1 e5 30     30 ae f1 e5     e5 9a 7a 4c     17 b1 39 05     f2 2b 43 49
</pre>
</p>
<p>
The correct output is either third state on the second row or the fifth state.
</p>
</div>
<div>
<p><em>Last updated on Tuesday, May 10th, 2016.</em></p>
</div>
</body>
</html>
